<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="年份" prop="year">
        <el-select
          v-model="queryParams.year"
          placeholder="请选择年份"
          clearable
        >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-select
          v-model="queryParams.month"
          placeholder="请选择月份"
          clearable
        >
          <el-option label="01" value="01"></el-option>
          <el-option label="02" value="02"></el-option>
          <el-option label="03" value="03"></el-option>
          <el-option label="04" value="04"></el-option>
          <el-option label="05" value="05"></el-option>
          <el-option label="06" value="06"></el-option>
          <el-option label="07" value="07"></el-option>
          <el-option label="08" value="08"></el-option>
          <el-option label="09" value="09"></el-option>
          <el-option label="10" value="10"></el-option>
          <el-option label="11" value="11"></el-option>
          <el-option label="12" value="12"></el-option>
        </el-select>
      </el-form-item>
      <!-- <el-form-item
          label="时间"
          prop="appDate"
          label-width="150px"
        >
          <el-date-picker
            v-model="appDate"
            type="daterange"
            @input="appDateInput2"
            range-separator="至"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            clearable
          />
        </el-form-item> -->




      <el-form-item style="margin-left: 25px;">
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
        <el-button type="primary"  size="mini" @click="handleExport"
          >导出列表</el-button
        >
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table
        v-loading="loading"
        :data="Population"
        :max-height="maxHeight"
        :header-cell-style="{ background: '#2a8eed', color: '#fafcfe' }"
      >
        <el-table-column :label="zbctitle" align="center">

          <el-table-column label="排名" align="center" >
              <template slot-scope="scope">
                <span>{{ scope.row['ranking'] }}</span>
              </template>
          </el-table-column>
          <el-table-column label="地区" align="center" >
            <template slot-scope="scope">
              <span>{{ scope.row['areaName'] }}</span>
            </template>
          </el-table-column>
          <el-table-column label="集成电路布图设计登记发证量" align="center" >
            <template slot-scope="scope">
              <span>{{ scope.row['totalCnt'] }}</span>
            </template>
          </el-table-column>


        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
  import {listRank} from '@/api/circuit/cIntegratedCircuit';
  import{getyearList} from '@/api/staticdata'
export default {
  name: "NationalrankingofIntegrated",
  data() {
    return {
      maxHeight: 0,
      yearList: [],
      headerList: [],
      hearderTitle: "统计时期:2022",
      yearColumn1: "年",
      yearColumn2: "年发明专利有效量（件）",
      yearColumn3: "年人口（万人）",
      opensb:false,
      regionOptions: {},
      ysDistrictCounty: [],
      Population:[],
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      appDate:[],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专利有效-万人发明拥有量统计表格数据
      popuYearList: ['排名','地区','集成电路布图设计登记量'],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        patentType: null,
        cityCode: null,
        cityName: null,
        year: "2022",
        month: "12",
        higherSchool: null,
        researchInstitute: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      zbctitle:''
    };
  },
  created() {
    this.getHeader();
    this.getList();
    this.$nextTick(() => {
      this.maxHeight = window.innerHeight - 200; //300是页面中除了表格外其他组件的高度
    });
    this.yearList = getyearList()
    this.zbctitle = `统计时期${this.queryParams.year}${this.queryParams.month}`
  },
  methods: {
    appDateInput2(){
      this.$nextTick(() => {
        if (e == null) {
          this.queryParams.applyAdjustmentTimeBegin = null;
          this.queryParams.applyAdjustmentTimeEnd = null;
        } else {
          this.$set(this, "activityRegs3", [e[0], e[1]]);
          this.queryParams.applyAdjustmentTimeBegin =
            this.activityRegs3[0] + " " + "00:00:00";
          this.queryParams.applyAdjustmentTimeEnd =
            this.activityRegs3[1] + " " + "23:59:59";
        }
      });
    },
    /** 获取动态表头 */
    getHeader() {
      let head = "统计时期";
      this.hearderTitle = head;
    },


    /** 查询专利有效-万人发明拥有量统计列表 */
    getList() {
      this.loading = true;
      this.zbctitle = `统计时期${this.queryParams.year}${this.queryParams.month}`
      listRank(this.queryParams).then(response=>{
        this.loading = false;
        this.Population = response.data
      })
    },


    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        patentType: null,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        higherSchool: null,
        researchInstitute: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (this.queryParams.month) {
        if (this.queryParams.year) {
          this.getHeader();
          this.queryParams.pageNum = 1;
          this.getList();
        } else {
          this.$message("请选择年份");
        }
      } else {
        this.getHeader();
        this.queryParams.pageNum = 1;
        this.getList();
      }
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专利有效-万人发明拥有量统计";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getRzlInventStatisticsInfo(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专利有效-万人发明拥有量统计";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateRzlInventStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzlInventStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm(
          '是否确认删除专利有效-万人发明拥有量统计编号为"' + ids + '"的数据项？'
        )
        .then(function () {
          return delRzlInventStatisticsInfo(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "circuit/cIntegratedCircuit/exportRank",
        {
          ...this.queryParams,
        },
        `rzlInventStatisticsInfo_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
